import java.awt.*;
import java.awt.event.*;
import java.lang.Math;
public class TwoDimDFT extends Frame
{  
   public double Xaxis, Yaxis;       // _ʒu
   public double sX, sY;             // XP[
   public double currentX, currentY; // ݂̕`ʒu
   public TwoDimDFT()
   {  setSize(800,400);
      addWindowListener(new WindowAdapter()
      { public void windowClosing(WindowEvent e){System.exit(0);}
      });
   }
   private Complex[][] fn(int Max)
   {  Complex [][] X = new Complex[Max+1][Max+1];
      double DX = 0.3; double V;
      for(int j = 0; j <= Max; j++)
      { double XX = (((double)j) - ((double) Max) / 2) * DX;
        for(int k = 0; k<= Max; k++)
        {  double YY = (((double)k) - ((double)Max) / 2) * DX;
           double R = Math.sqrt(XX * XX + YY * YY);
           if(R< 0.00001) V = 1;
           else           V = Math.sin(R) / R;
            X[j][k] = new Complex(V, 0);
        }
      }
      return X;
   }
   private Complex [][] DFT(Complex[][]X, int Max) //@2DFT
   { int m = Max; double PM = -6.28318530717959 / m; int i, k, N;
     Complex[][] Y1 = new Complex[m + 1][m + 1];
     Complex[][] Y2 = new Complex[m + 1][m + 1];
     for(k = 0; k<= m; k++)for(N = 0; N <= m; N++)
     {  double DD = (((k+N) % 2)==0 ? 1: -1);
        Y2[k][N] = X[k][N].mult(DD);
     }
     for(i = 0; i < m; i++)
     {  for(k = 0; k < m; k++)
        {  Y1[i][k] = new Complex(0, 0);
           for(N = 0; N < m; N++) Y1[i][k] =Y1[i][k].add(Y2[i][N].mult(Complex.expJ(PM * N * k)));
        }
        Y1[i][Max] = Y1[i][0];
     }
     for(i= 0; i < m; i++)
     {  for(k = 0; k < m; k++)
        {  Y2[k][i] = new Complex(0, 0);
           for(N = 0; N < m; N++) Y2[k][i] =Y2[k][i].add(Y1[N][i].mult(Complex.expJ(PM * N * k )));
        }
        Y2[Max][i] = Y2[0][i];
     }
     return Y2;
   }
   private Complex [][] IDFT(Complex[][]Y, int Max)  // t2DFT
   {  int m = Max; double PM = 6.28318530717959 / m; int i, k, N;
      Complex[][] Z1 = new Complex[Max + 1][Max + 1];
      Complex[][] Z2 = new Complex[Max + 1][Max + 1];
      for(i = 0; i <= m; i++) for(k = 0; k <= m; k++) Z1[i][k] = new Complex(0,0);
      for(i = 0; i <= m; i++) for(k = 0; k <= m; k++) Z2[i][k] = new Complex(0,0);
      for(i = 0; i < m; i++)
      {  for(k = 0; k <= m; k++)
         {  Z2[i][k] = new Complex(0, 0);
            for(N = 0; N < m; N++)
              Z2[i][k] = Z2[i][k].add(Y[i][N].mult(Complex.expJ(PM * N * k )));
         }
         Z2[i][Max] = Z2[i][0];
      }
      for(i = 0; i <= m; i++) for(k = 0; k <= m; k++) Z2[i][k] = (Z2[i][k]).div((double)m);
      for(i = 0; i <  m; i++)
      {  for(k = 0; k < m; k++)
         {  Z1[k][i] = new Complex(0, 0);
            for(N = 0; N < m; N++) Z1[k][i] = Z1[k][i].add(Z2[N][i].mult(Complex.expJ(PM * N * k)));
         }
         Z1[Max][i] = Z1[0][i];
      }
     for(k = 0; k < m; k++) for(N = 0; N <  m; N++)
     {  double DD= (double)(((k+N) % 2)==0 ? 1: -1);
        Z2[k][N] = Z1[k][N].mult(DD);
     }
     for(i = 0; i <= m; i++) for(k = 0; k <= m; k++) Z2[i][k] = (Z2[i][k]).div((double)m);
     return Z2;
   }
     
   public double maxComplexValue(Complex[][] C, int N1, int N2)
   {  double M=C[0][0].R; int i,j;
      for(i=0;i<= N1; i++)for(j = 0; j<= N2;j++)
      { if(M < C[i][j].R) M = C[i][j].R;
        if(M < C[i][j].I) M = C[i][j].I;
      }
      return M;
   } 
   public double minComplexValue(Complex[][] C, int N1, int N2)
   {  double M=C[0][0].R; int i,j;
      for(i=0;i<= N1; i++)for(j = 0; j<= N2;j++)
      { if(M > C[i][j].R) M = C[i][j].R;
        if(M > C[i][j].I) M = C[i][j].I;
      }
      return M;
   } 
   public int Xpos(double X)
   {  return (int)(X * sX +Xaxis);}
   public int Ypos(double Y)
   {  return (int)(Yaxis- Y * sY);}
   public int Xlen(double X)
   {  return (int)(X * sX );}
   public int Ylen(double Y)
   {  return (int)(Y * sY);}
   public void drawLine(Graphics g, double X1, double Y1, double X2, double Y2)
   {  g.drawLine(Xpos(X1),Ypos(Y1),Xpos(X2),Ypos(Y2));
   }
   public void fillRect(Graphics g, double X1, double Y1, double W, double H,Color C)
   { g.setColor(C);
     g.fillRect(Xpos(X1),Ypos(Y1),Xlen(W),Ylen(H));
   }
   public void drawPoint(Graphics g, double X, double Y)
   {  g.drawOval(Xpos(X)-2,Ypos(Y)-2,4,4);
   }
   public boolean Draw(Graphics g, double X, double Y, boolean Flag)
   {  if(Flag) drawLine(g, currentX, currentY, X, Y);
      currentX = X; currentY = Y;
      return true;
   }
   public void drawInit(double X0, double Y0, double SX, double SY)
   { Xaxis=X0; Yaxis=Y0; sX=SX; sY=SY;
   }
   private double round(double D,int N)
   {  double DN=10*Math.pow(10.0,(double)(N-1));
      return Math.rint(D*DN)/DN;
   }

   private void drawReal(Graphics g, Complex[][] X, int Max)
   { double MaxV = maxComplexValue(X, Max, Max);double MinV = minComplexValue(X, Max, Max);
     double DH=(MaxV - MinV ) / 256; int Mhalf= Max-1;
     for(int i = 0; i <= Max; i++) for(int j = 0; j<= Max; j++)
     {   int H = (int)((X[i][j].R - MinV)/DH); if(H>255) H = 255;
         fillRect(g, j, i, 1, 1, new Color(H,H,H)); 
     } 
     g.setColor(new Color(0,0,0));
     g.drawString("Max = " + round(MaxV,4) + " Min = " + round(MinV,4), Xpos(0),Ypos(-20));
   }
   private void drawImage(Graphics g, Complex[][] X, int Max)
   {
     double MaxV = maxComplexValue(X, Max, Max);double MinV = minComplexValue(X, Max, Max);
     double DH=(MaxV - MinV ) / 256; int Mhalf= Max-1;
     for(int i = 0; i <= Max; i++) for(int j = 0; j<= Max; j++)
     {   int H = (int)((X[i][j].I - MinV)/DH); if(H>255) H = 255;
         fillRect(g, j, i, 1, 1, new Color(H,H,H)); 
     } 
   }
   public void paint(Graphics g)
   { 
     int Max = 100;
     setTitle("񎟌DFT");
     Complex [][] X = fn(Max);
     drawInit( 50,200,1,1); drawReal (g, X, Max);
     drawInit(200,200,1,1); drawImage(g, X, Max);
     
     Complex [][] Y = DFT(X, Max); //@2DFT
     drawInit(450,280,1,1); drawReal (g, Y, Max);
     drawInit(600,280,1,1); drawImage(g, Y, Max);
     g.drawString(" DFT ",350,190);

     Complex [][] Z = IDFT(Y, Max); //@2IDFT
     drawInit( 50,370,1,1); drawReal (g, Z, Max);
     drawInit(200,370,1,1); drawImage(g, Z, Max);
     g.drawString(" IDFT",350,280);
   } 
   public static void main(String[] args)
   {  Frame w = new TwoDimDFT();
      w.setVisible(true);
   }
}
